drop function fsql_semantic_calcula_cdeg(numeric(10),numeric(10),varchar(100),
					 varchar(2000),numeric(10));
create function fsql_semantic_calcula_cdeg(numeric(10),numeric(10),varchar(100),
					 varchar(2000),numeric(10))
returns integer as '
declare

  columna_indice alias for $1;
  columna_posicion alias for $2;
  columna_nombre alias for $3;
  columna_atributo alias for $4;
  maxind alias for $5;
  maxind_var integer;
  inicio_var numeric(10);
  fin_var    numeric(10);
  nomb   varchar(100);
  condic record;
  cont   integer;
  tupla_var  integer;
  stc    varchar(92);

  max_cdeg_var integer;
  haya_parentesis boolean;

  scheme_var varchar(30);
  tab_var    varchar(30);
  f_tipo_var numeric(1);
  obj_var numeric;
  col_var numeric;
  cadena varchar;
  cadena2 varchar;
  cadena3 varchar;
  cadena4 varchar;
  cadena5 varchar;
  llama_funcion integer;
  llama_funcion2 boolean;
  atributo_var varchar(2000);

  ind numeric(10);
  atr varchar(2000);
  final integer;
  ini integer;
begin
  insert into trama values(nextval(''sec''),''fsql_semantic_calcula_cdeg'');
  select into tupla_var tupla from variables;
  select into scheme_var scheme from variables;
  select into tab_var tab from variables;
  select into f_tipo_var f_tipo from variables;
  select into obj_var obj from variables;
  select into col_var col from variables;

  scheme_var:=''public'';
  maxind_var:=maxind;
  inicio_var:=columna_indice+1;
  cont:=0;
  haya_parentesis:=''t'';

  delete from cdeg;
  select into final max(indice) from fsql_all_queries;
  ini:=0;
     loop
	select into ind,atr indice,atributo from fsql_all_queries where indice=ini;
	if ini>final then
	   exit;
	elsif found then
	   insert into cdeg values(ind,atr);
	end if;
	ini:=ini+1;
     end loop;

  stc:=substr(columna_nombre,1,length(columna_nombre)-4);
  cadena:='' as "cdeg(''||columna_atributo||'')"'';
  update fsql_all_queries set nombre=''cdeg c_alias'',atributo=cadena
    where indice=columna_indice+1;

  loop
	select into nomb nombre from fsql_all_queries where indice=inicio_var;
	if (nomb=''where'' and cont=0) or inicio_var=maxind_var then
		exit;
	end if;
	if nomb=''select'' then
		cont:=cont+1;
	elsif nomb=''where''  then
		cont:=cont-1;
	end if;
	inicio_var:=inicio_var+1;
  end loop;

  if nomb<>''where'' then
	llama_funcion:=fsql_semantic_cdegnoaplicable(columna_indice,columna_posicion);
	return 0;
  end if;

  inicio_var:=inicio_var+1;
  fin_var:=inicio_var;
  cont:=0;
  loop
	select into nomb nombre from fsql_all_queries where indice=fin_var;
	if fin_var>=maxind_var or
              nomb in (''group'', ''connect'' ,''start'' ,''union'' ,''intersect'' ,''minus'' ,''order'' ,'';'') or
              (nomb='')'' and cont=0) then
		exit;
	end if;
	if nomb=''('' then
		cont:=cont+1;
	elsif nomb='')'' then
		cont:=cont-1;
	end if;
	fin_var:=fin_var+1;
  end loop;
  if nomb in (''group'' ,''connect'' ,''start'' ,''union'' ,''intersect'' ,''minus'' ,''order'' ,'';'') then
     fin_var:=fin_var-1;
  end if;

  max_cdeg_var:=0;
  cont:=inicio_var;
  cadena:=''*''||''\\134'';
  if stc= cadena then
     while cont<=fin_var loop
	select into condic indice,posicion,nombre,atributo from fsql_all_queries
         where indice=cont;
	if condic.atributo is not null then
	  cadena:=substr(condic.nombre,length(condic.nombre),1);
	  cadena2:=substr(condic.nombre,length(condic.nombre)-7,8);
	  cadena3:=substr(condic.nombre,length(condic.nombre)-5,6);
          if cadena = ''\\134'' then
		max_cdeg_var:=max_cdeg_var+1;
		cadena:=fsql_semantic_grado_condicion(condic.indice, condic.atributo ,tupla_var);
		update cdeg set atributo=''cadena uno '' where indice=max_cdeg_var;
		cont:=cont+tupla_var;

	  elsif condic.atributo in (''and'',''or'') then
		select into atributo_var atributo from cdeg where indice=max_cdeg_var;
	     if atributo_var not in (''not'',''and'',''or'') then
		max_cdeg_var:=max_cdeg_var+1;
	     end if;
		update cdeg set atributo=''condic.atributo'' where indice=max_cdeg_var;
	  elsif condic.atributo=''not'' then
		max_cdeg_var:=max_cdeg_var+1;
		update cdeg set atributo=''condic.atributo'' where indice=max_cdeg_var;
	  elsif condic.atributo in (''('','')'') and cadena2 <> ''function'' then
		max_cdeg_var:=max_cdeg_var+1;
		update cdeg set atributo=''condic.atributo'' where indice=max_cdeg_var;
	  elsif condic.atributo in (''{'',''}'') then
		max_cdeg_var:=max_cdeg_var+1;
		update cdeg set atributo=''condic.atributo'' where indice=max_cdeg_var;
	  elsif condic.nombre=''crisp_col'' or	cadena3 = ''column'' then
		max_cdeg_var:=max_cdeg_var+1;
		select into tupla_var tupla from variables;
		cadena:=fsql_semantic_grado_condcrisp(condic.indice,tupla_var);
		update cdeg set atributo=''cadena dos'' where indice=max_cdeg_var;

		select into atributo_var atributo from cdeg where indice=max_cdeg_var;
	     if atributo_var is null then
		max_cdeg_var:=max_cdeg_var-1;
	     else
		cont:=cont+tupla_var;
		cadena:=fsql_semantic_operador_anterior(condic.indice);
		cadena2:=fsql_semantic_operador_siguiente(condic.indice);
		if cadena<>''or'' and cadena2<>''or'' then
		   update cdeg set atributo=''aki uno'' where indice=max_cdeg_var;
		end if;
	     end if;
	  end if;
	end if;
	cont:=cont+1;
     end loop;
--- noe
  else
     while cont<=fin_var loop
	select into condic indice,posicion,nombre,atributo from fsql_all_queries
         where indice=cont;
	cadena:=substr(condic.nombre,length(condic.nombre)-2,3);
	cadena2:=''\\134''||''2''||''\\134'';
	cadena3:=substr(condic.nombre,length(condic.nombre)-5,6);
	cadena4:=substr(condic.nombre,length(condic.nombre),1);
	cadena5:=substr(condic.nombre,length(condic.nombre)-7,8);
	if cadena <> cadena2 then
	  if condic.nombre=stc then
		max_cdeg_var:=max_cdeg_var+1;
		select into tupla_var tupla from variables;
		cadena:=fsql_semantic_grado_condicion(condic.indice, condic.atributo ,tupla_var);
		update cdeg set atributo=''cadena tres'' where indice=max_cdeg_var;
		cont:=cont+tupla_var;
	  elsif cadena3 = ''column'' then
		max_cdeg_var:=max_cdeg_var+1;
		llama_funcion2:=fsql_semantic_es_fuzzy_column(condic.indice, condic.posicion, condic.nombre, condic.atributo,scheme_var,tab_var,f_tipo_var,obj_var,col_var);
		select into scheme_var scheme from variables;
		scheme_var:= ''public'';
		select into tab_var tab from variables;
		cadena3:=scheme_var||''.''||tab_var||''.''||condic.atributo||''\\134'';
	    if llama_funcion2=''t'' and	stc=cadena3 then
		cadena:=fsql_semantic_operador_anterior(condic.indice);
		cadena2:=fsql_semantic_operador_siguiente(condic.indice);
		if cadena=''or'' or cadena2=''or'' then
		   select into tupla_var tupla from variables;
		   cadena3:=fsql_semantic_grado_condcrisp(condic.indice,tupla_var);
		   update cdeg set atributo=''cadena3 cuatro'' where indice=max_cdeg_var;
		   if cadena3 is null then
			max_cdeg_var:=max_cdeg_var-1;
		   else
			select into tupla_var tupla from variables;
			cont:=cont+tupla_var;
		   end if;
		else
		   update cdeg set atributo=''aki uno'' where indice=max_cdeg_var;
		end if;
	    else
		cadena=''\\134''||''\\134'';
		update cdeg set atributo=''cadena cinco'' where indice=max_cdeg_var;
	    end if;

	  elsif cadena4 = ''\\134'' or condic.nombre=''crisp_col'' then
		max_cdeg_var:=max_cdeg_var+1;
		cadena=''\\134''||''\\134'';

		update cdeg set atributo=''cadena seis'' where indice=max_cdeg_var;
	  elsif condic.atributo in (''and'',''or'') then
		select into atributo_var atributo from cdeg where indice=max_cdeg_var;
	     if atributo_var not in (''not'',''and'',''or'') then
		max_cdeg_var:=max_cdeg_var+1;
	     end if;
	     update cdeg set atributo=''condic.atributo'' where indice=max_cdeg_var;
	  elsif condic.atributo=''not'' then
		max_cdeg_var:=max_cdeg_var+1;
		update cdeg set atributo=''condic.atributo'' where indice=max_cdeg_var;
	  elsif condic.atributo in (''{'',''}'') then
		max_cdeg_var:=max_cdeg_var+1;
		update cdeg set atributo=''condic.atributo'' where indice=max_cdeg_var;
	  elsif condic.atributo in (''('','')'') and cadena4 <> ''function'' then
		max_cdeg_var:=max_cdeg_var+1;
		update cdeg set atributo=''condic.atributo'' where indice=max_cdeg_var;
		--cdeg(max_cdeg_var):=condic.atributo;
	  end if;

	else
	  cadena:=stc||''2''||''\\134'';
	  if condic.nombre=cadena then
		tupla_var:=condic.indice-2;
		update variables set tupla=tupla_var;
		cadena2:=''\\134'';
	     loop
		select into condic indice,posicion,nombre,atributo from fsql_all_queries
                 where indice=tupla_var;
		if condic.nombre = cadena2 then
			exit;
		end if;
		tupla_var:=tupla_var-1;
	     end loop;
		update variables set tupla=tupla_var;
		cadena:=fsql_semantic_grado_condicion(condic.indice, condic.atributo ,tupla_var);
		update cdeg set atributo=''cadena siete'' where indice=max_cdeg_var;
	  end if;
	end if;
	cont:=cont+1;
     end loop;
  end if;

  if max_cdeg_var=0 then
	max_cdeg_var:=1;
	cadena=''\\134''||''\\134'';
	update cdeg set atributo=''cadena ocho'' where indice=1;
  end if;
  select into atributo_var atributo from cdeg where indice=max_cdeg_var;
  while atributo_var in (''not'',''and'',''or'') loop
	max_cdeg_var:=max_cdeg_var-1;
	select into atributo_var atributo from cdeg where indice=max_cdeg_var;
  end loop;

  while haya_parentesis=''t'' loop
	inicio_var:=1;
	fin_var:=1;
	select into atributo_var atributo from cdeg where indice=fin_var;
    while fin_var<=max_cdeg_var and atributo_var not in ('')'',''}'') loop
      if atributo_var in (''('',''{'') then
	inicio_var:=fin_var;
      end if;
	fin_var:=fin_var+1;
	select into atributo_var atributo from cdeg where indice=fin_var;
    end loop;

    if fin_var>max_cdeg_var then
	cadena:=''*''||''\\134'';
	if stc=cadena then
	   fin_var:=fsql_semantic_cambia_oper_logicos(max_cdeg_var,1,max_cdeg_var);
           select into max_cdeg_var max_cdeg from variables;
	else
	   fin_var:=fsql_semantic_cambia_oper_logicos2(max_cdeg_var,1,max_cdeg_var);
           select into max_cdeg_var max_cdeg from variables;
	end if;
	haya_parentesis:=''f'';
    else
	cadena:=''*''||''\\134'';
	if stc= cadena then
	   fin_var:=fsql_semantic_cambia_oper_logicos(max_cdeg_var,inicio_var,fin_var);
           select into max_cdeg_var max_cdeg from variables;
	else
	   fin_var:=fsql_semantic_cambia_oper_logicos2(max_cdeg_var,inicio_var,fin_var);
           select into max_cdeg_var max_cdeg from variables;
	end if;
    end if;
  end loop;
  select into atributo_var atributo from cdeg where indice=1;
  cadena:=''\\134''||''\\134'';
  if atributo_var=cadena then
	llama_funcion:=fsql_semantic_cdegnoaplicable(columna_indice,columna_posicion);
  else
	update fsql_all_queries set atributo=''atributo_var'' where indice=columna_indice;
  end if;
  return 0;
end;
'language 'plpgsql';
